searchNodes=[{"ref":"FieldMask.html","title":"FieldMask","type":"module","doc":"FieldMask implements Partial Responses protocol of Google+ API purely in Elixir via algorithmic method."},{"ref":"FieldMask.html#compile/1","title":"FieldMask.compile/1","type":"function","doc":"Compile text with Partial Responses protocol of Google+ API Examples iex&gt; FieldMask.compile(&quot;a,b,c&quot;) {:ok, %{&quot;a&quot; =&gt; %{}, &quot;b&quot; =&gt; %{}, &quot;c&quot; =&gt; %{}}} iex&gt; FieldMask.compile(&quot;a/b/c&quot;) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; %{}}}}} iex&gt; FieldMask.compile(&quot;a(b,c)&quot;) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{}, &quot;c&quot; =&gt; %{}}}} iex&gt; FieldMask.compile(&quot;a/*/c&quot;) {:ok, %{&quot;a&quot; =&gt; %{&quot;*&quot; =&gt; %{&quot;c&quot; =&gt; %{}}}}} iex&gt; FieldMask.compile(&quot;a/b,c&quot;) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{}}, &quot;c&quot; =&gt; %{}}} iex&gt; FieldMask.compile(&quot;ob,a(k,z(f,g/d))&quot;) { :ok, %{ &quot;a&quot; =&gt; %{&quot;k&quot; =&gt; %{}, &quot;z&quot; =&gt; %{&quot;f&quot; =&gt; %{}, &quot;g&quot; =&gt; %{&quot;d&quot; =&gt; %{}}}}, &quot;ob&quot; =&gt; %{} } } iex&gt; FieldMask.compile(&quot;url,object(content,attachments/url)&quot;) {:ok, %{ &quot;object&quot; =&gt; %{&quot;attachments&quot; =&gt; %{&quot;url&quot; =&gt; %{}}, &quot;content&quot; =&gt; %{}}, &quot;url&quot; =&gt; %{} }} iex&gt; FieldMask.compile(&quot;a(b,c&quot;) {:error, &quot;Invalid text with mismatched brackets: a(b,c&quot;}"},{"ref":"FieldMask.html#mask/2","title":"FieldMask.mask/2","type":"function","doc":"Get JSON result as a map masked by text Examples iex&gt; FieldMask.mask(&quot;a,b&quot;, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) {:ok, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2}} iex&gt; FieldMask.mask(&quot;a/b&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 2}}} iex&gt; FieldMask.mask(&quot;a(b,c)&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; 2, &quot;d&quot; =&gt; 3}, &quot;e&quot; =&gt; 4}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; 2}}} iex&gt; FieldMask.mask(&quot;a/*/c&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 2, &quot;e&quot; =&gt; 1}, &quot;d&quot; =&gt; %{ &quot;c&quot; =&gt; 4, &quot;f&quot; =&gt; 3}}}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 2}, &quot;d&quot; =&gt; %{&quot;c&quot; =&gt; 4}}}} iex&gt; FieldMask.mask(&quot;a/b)&quot;, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) {:error, &quot;Invalid text with mismatched brackets: a/b)&quot;}"},{"ref":"FieldMask.html#parse/1","title":"FieldMask.parse/1","type":"function","doc":"Parse JSON tree from tokens"},{"ref":"FieldMask.html#scan/1","title":"FieldMask.scan/1","type":"function","doc":"Get tokens from text Examples iex&gt; FieldMask.scan(&quot;ob,a(k,z(f,g/d))&quot;) [&quot;ob&quot;, &quot;,&quot;, &quot;a&quot;, &quot;(&quot;, &quot;k&quot;, &quot;,&quot;, &quot;z&quot;, &quot;(&quot;, &quot;f&quot;, &quot;,&quot;, &quot;g&quot;, &quot;/&quot;, &quot;d&quot;, &quot;)&quot;, &quot;)&quot;] iex&gt; FieldMask.scan(&quot;ob,a(k,z(f,g/d)),d&quot;) [&quot;ob&quot;, &quot;,&quot;, &quot;a&quot;, &quot;(&quot;, &quot;k&quot;, &quot;,&quot;, &quot;z&quot;, &quot;(&quot;, &quot;f&quot;, &quot;,&quot;, &quot;g&quot;, &quot;/&quot;, &quot;d&quot;, &quot;)&quot;, &quot;)&quot;, &quot;,&quot;, &quot;d&quot;] iex&gt; FieldMask.scan(&quot;&quot;) [] iex&gt; FieldMask.scan(&quot;abc/*&quot;) [&quot;abc&quot;, &quot;/&quot;, &quot;*&quot;]"},{"ref":"readme.html","title":"FieldMask","type":"extras","doc":"FieldMask FieldMask implements Partial Responses protocol of Google+ API purely in Elixir via algorithmic method rather than grammar way which is adopted by fieldmask. It&#39;s the counterpart of JSON Mask in JavaScript and jsonmask in Python."},{"ref":"readme.html#installation","title":"FieldMask - Installation","type":"extras","doc":"The package can be installed by adding ex_fieldmask to your list of dependencies in mix.exs: def deps do [ {:ex_fieldmask, &quot;~&gt; 0.3.0&quot;} # replace version with newest one ] end"},{"ref":"readme.html#examples","title":"FieldMask - Examples","type":"extras","doc":"iex&gt; FieldMask.mask(&quot;a,b&quot;, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) {:ok, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2}} iex&gt; FieldMask.mask(&quot;a/b&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 2}}} iex&gt; FieldMask.mask(&quot;a(b,c)&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; 2, &quot;d&quot; =&gt; 3}, &quot;e&quot; =&gt; 4}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; 2}}} iex&gt; FieldMask.mask(&quot;a/*/c&quot;, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 2, &quot;e&quot; =&gt; 1}, &quot;d&quot; =&gt; %{ &quot;c&quot; =&gt; 4, &quot;f&quot; =&gt; 3}}}) {:ok, %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; 2}, &quot;d&quot; =&gt; %{&quot;c&quot; =&gt; 4}}}} iex&gt; FieldMask.mask(&quot;a/b)&quot;, %{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) {:error, &quot;Invalid text with mismatched brackets: a/b)&quot;} Check test folder to see more examples. It returns {:ok, masked_json} or {:error, error_message}. masked_json is either a Map or a List in Elixir and error_message is a String. Besides, if text in invalid or data isn&#39;t a decoded JSON, exception would be raised. You are expected to rescue the exception or just let it crash catering to the actual condition. Use Poison or other JSON related packages to encode/decode a JSON to/from inner data structure of Elixir."},{"ref":"readme.html#one-more-thing","title":"FieldMask - One more thing","type":"extras","doc":"Take a look at json-mask#syntax for the syntax and grammar of Partial Responses protocol of Google+ API. Unlike package fieldmask also in the Seniverse orgnization, this one adopt algorithmic way to parse descriptive text and mask your data object. By this way, it&#39;s not that strict while parsing text. For example, &quot;a(b)c&quot; is equivalent to &quot;a(b),c&quot; although you miss the comma ,. They can both pass the validation and compiled as %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{}}, &quot;c&quot; =&gt; %{}} to do the masking job. This is intentional but you should always use the strict valid syntax."},{"ref":"readme.html#benchmark","title":"FieldMask - Benchmark","type":"extras","doc":"See fieldmask_benchmark."},{"ref":"readme.html#changelog","title":"FieldMask - ChangeLog","type":"extras","doc":"CHANGELOG"},{"ref":"readme.html#license","title":"FieldMask - License","type":"extras","doc":"Apache 2.0"},{"ref":"changelog.html","title":"CHANGELOG","type":"extras","doc":""},{"ref":"changelog.html#0-3-2-june-18-2019","title":"CHANGELOG - 0.3.2 (June 18, 2019)","type":"extras","doc":"simpify code of list comprehensions"},{"ref":"changelog.html#0-3-1-june-18-2019","title":"CHANGELOG - 0.3.1 (June 18, 2019)","type":"extras","doc":"adopt list comprehensions to replace Enum.map to improve performance make reveal a private function"},{"ref":"changelog.html#0-3-0-june-16-2019","title":"CHANGELOG - 0.3.0 (June 16, 2019)","type":"extras","doc":"let it crash, do not rescue inside simlify and refactor implement with pattern matching to improve performace"},{"ref":"changelog.html#0-2-0-june-15-2019","title":"CHANGELOG - 0.2.0 (June 15, 2019)","type":"extras","doc":"make a/*/c when field a is an array invalid refactor code to apply more pattern matching update doc and description"},{"ref":"changelog.html#0-1-0-june-13-2019","title":"CHANGELOG - 0.1.0 (June 13, 2019)","type":"extras","doc":"finish basic function and publish it to Hex with ❤️"}]